<template>
	<xn-form-container
		:title="formData.id ? '编辑报送周期' : '增加报送周期'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="报送周期；周一：1.....周日：7；：" name="dayOfWeek">
				<a-input v-model:value="formData.dayOfWeek" placeholder="请输入报送周期；周一：1.....周日：7；" allow-clear />
			</a-form-item>
			<a-form-item label="报送开始时间：" name="startTime">
				<a-date-picker v-model:value="formData.startTime" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择报送开始时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="报送结束时间：" name="endTime">
				<a-date-picker v-model:value="formData.endTime" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择报送结束时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="提前提醒；提前小时数；：" name="advanceHour">
				<a-input v-model:value="formData.advanceHour" placeholder="请输入提前提醒；提前小时数；" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="remindCycleForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import remindCycleApi from '@/api/basic.info/remindCycleApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			remindCycleApi
				.remindCycleSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
